// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/common/charts/rickshaw/FormatUtils","cloudera/common/charts/rickshaw/Visualizer","underscore"],function(e,t,n){describe("Visualizer Tests",function(){var r=[{data:[{x:1,y:1},{x:2,y:2}],metadata:{label:"Foo"}},{data:[{x:2,y:2},{x:3,y:3}],metadata:{label:"Bar"}}],i=function(e){return[{data:[{x:1,y:e},{x:2,y:e}],metadata:{label:"Bar"}},{data:[{x:2,y:e},{x:3,y:e}],metadata:{label:"Foo"}}]},s={container:"#chartContainer",width:100,height:60},o,u={render:function(){},configure:function(e){o=e},onUpdate:function(){},append:function(){}},a={render:function(){}},f={render:function(){},element:{}};beforeEach(function(){$('<div id="chartContainer"><div class="chart"></div></div>').appendTo(document.body)}),afterEach(function(){$("#chartContainer").remove()}),it("should call graph.render",function(){var e=new t(s);spyOn(e,"createGraph").andReturn(u),spyOn(e,"createAxisX").andReturn(a),spyOn(e,"createAxisY").andReturn(f),spyOn(u,"render"),e.render(r),expect(e.createGraph).wasCalled(),expect(u.render).wasCalled()}),it("should not show the Y axis",function(){var e=new t($.extend({},s,{showYAxis:!1}));e.render(r),expect(e.yAxis).toBeUndefined()}),it("should not show the legend by default",function(){var e=new t(s);e.render(r),expect(e.legend).toBeUndefined(),expect(e.legendToggle).toBeUndefined(),expect(e.legendHighlight).toBeUndefined()}),it("should show the legend",function(){$("#chartContainer").append($('<div class="legend"/>'));var e=new t($.extend({},s,{showLegend:!0}));e.render(r),expect(e.legend).toBeDefined(),expect(e.legendToggle).toBeDefined(),expect(e.legendHighlight).toBeDefined(),$(".legend").remove()}),it("should show the Y-axis with units set",function(){var i=new t(n.defaults(s,{showYAxis:!0}));spyOn(i,"createAxisY").andReturn(f),f.setUnits=jasmine.createSpy("setUnits"),spyOn(e,"getFirstUnits").andReturn({numerators:["cats"],denominators:["pants"]}),i.render(r),expect(f.setUnits).wasCalled()}),it("should call configure",function(){var e=new t(s);spyOn(e,"createGraph").andReturn(u),spyOn(e,"createAxisX").andReturn(a),spyOn(e,"createAxisY").andReturn(f),spyOn(u,"configure"),spyOn(u,"render"),e.render(r),e.update({width:60,height:50}),expect(u.configure).wasCalled(),expect(u.render).wasCalled()}),it("should test setting min and max value",function(){var e=$.extend({},s,{min:10,max:20}),n=new t(e);spyOn(n,"createGraph").andReturn(u),spyOn(n,"createAxisX").andReturn(a),spyOn(n,"createAxisY").andReturn(f),spyOn(u,"configure").andCallThrough(),spyOn(u,"render"),n.render(r),n.update({ymin:30,ymax:40}),expect(o.min).toEqual(30),expect(o.max).toEqual(40),n.update({ymin:undefined,ymax:40}),expect(o.min).toEqual(10),expect(o.max).toEqual(40),n.update({ymin:15,ymax:undefined}),expect(o.min).toEqual(15),expect(o.max).toEqual(20),n.update({ymin:undefined,ymax:undefined}),expect(o.min).toEqual(10),expect(o.max).toEqual(20)}),it("should test Y range setting when all the values are identical",function(){var e=new t(s);spyOn(e,"createGraph").andReturn(u),spyOn(e,"createAxisX").andReturn(a),spyOn(e,"createAxisY").andReturn(f),spyOn(u,"configure"),spyOn(u,"render"),e.render(i(0));var n=e.createGraph.mostRecentCall.args[0];expect(n.min).toEqual(0),expect(n.max).toEqual(1)}),it("should test Y range setting when all the values are not identical",function(){var e=new t(s);spyOn(e,"createGraph").andReturn(u),spyOn(e,"createAxisX").andReturn(a),spyOn(e,"createAxisY").andReturn(f),spyOn(u,"configure"),spyOn(u,"render"),e.render(r);var n=e.createGraph.mostRecentCall.args[0];expect(n.min).toBeUndefined(),expect(n.max).toBeUndefined()}),it("should test Y range setting when ymin, ymax are supplied",function(){var e=$.extend({},s,{ymin:10,ymax:20}),n=new t(e);spyOn(n,"createGraph").andReturn(u),spyOn(n,"createAxisX").andReturn(a),spyOn(n,"createAxisY").andReturn(f),spyOn(u,"configure"),spyOn(u,"render"),n.render(i(10));var r=n.createGraph.mostRecentCall.args[0];expect(r.min).toEqual(10),expect(r.max).toEqual(20)}),it("should test Y range setting for stacked area",function(){var e=$.extend({},s,{min:10,max:20,offset:"zero",renderer:"area"}),n=new t(e);spyOn(n,"createGraph").andReturn(u),spyOn(n,"createAxisX").andReturn(a),spyOn(n,"createAxisY").andReturn(f),spyOn(u,"configure"),spyOn(u,"render"),n.render(i(10));var r=n.createGraph.mostRecentCall.args[0];expect(r.min).toEqual(0),expect(r.max).toEqual(20)}),it("should test Y range setting for a collapsed dynamic range",function(){var e=$.extend({},s,{min:10,max:10}),n=new t(e);spyOn(n,"createGraph").andReturn(u),spyOn(n,"createAxisX").andReturn(a),spyOn(n,"createAxisY").andReturn(f),spyOn(u,"configure"),spyOn(u,"render"),n.render(i(10));var r=n.createGraph.mostRecentCall.args[0];expect(r.min).toEqual(0),expect(r.max).toEqual(10)}),it("should test Y range setting for bar charts",function(){var e=$.extend({},s,{min:1,max:2,offset:"zero",renderer:"bar"}),n=new t(e);spyOn(n,"createGraph").andReturn(u),spyOn(n,"createAxisX").andReturn(a),spyOn(n,"createAxisY").andReturn(f),spyOn(u,"configure"),spyOn(u,"render"),n.render(r);var i=n.createGraph.mostRecentCall.args[0];expect(i.min).toEqual(0),expect(i.max).toEqual(2)}),it("should test renderPlaceholder",function(){var e=new t(s);e.renderPlaceholder(),expect(e.$container.find(".chart").children().length).toEqual(0),expect(e.isRendered()).toBeFalsy()}),it("should test render and ensure isRendered returns true",function(){var e=new t(s);spyOn(e,"createGraph").andReturn(u),spyOn(e,"createAxisX").andReturn(a),spyOn(e,"createAxisY").andReturn(f),spyOn(u,"render"),expect(e.isRendered()).toBeFalsy(),e.render(r),expect(e.isRendered()).toBeTruthy()})})})